/**
 * lerna-utils
 * Internal utilities for interacting with a lerna monorepo
 */
/// <reference types="node" />
import * as fs from 'fs';
import * as F from 'fluture';
import { LernaPackage } from '@typescript-tools/io-ts/dist/lib/LernaPackage';
export declare const readFile: (file: fs.PathLike) => F.FutureInstance<NodeJS.ErrnoException, string>;
export declare const writeFile: (file: fs.PathLike) => (contents: string) => F.FutureInstance<NodeJS.ErrnoException, void>;
/**
 * Get list of all lerna packages from `lerna list --all`.
 */
export declare function lernaPackages(root: string): F.FutureInstance<unknown, LernaPackage[]>;
//# sourceMappingURL=lerna-utils.d.ts.map