"use strict";
/**
 * lerna-utils
 * Internal utilities for interacting with a lerna monorepo
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lernaPackages = exports.writeFile = exports.readFile = void 0;
const fs = __importStar(require("fs"));
const t = __importStar(require("io-ts"));
const E = __importStar(require("fp-ts/Either"));
const F = __importStar(require("fluture"));
const execa_1 = __importDefault(require("execa"));
const function_1 = require("fp-ts/lib/function");
const LernaPackage_1 = require("@typescript-tools/io-ts/dist/lib/LernaPackage");
const StringifiedJSON_1 = require("@typescript-tools/io-ts/dist/lib/StringifiedJSON");
const readFile = (file) => F.node(done => fs.readFile(file, 'utf8', done));
exports.readFile = readFile;
const writeFile = (file) => (contents) => F.node(done => fs.writeFile(file, contents, done));
exports.writeFile = writeFile;
// TODO: pull into its own package
/**
 * Get list of all lerna packages from `lerna list --all`.
 */
function lernaPackages(root) {
    return F.Future((reject, resolve) => {
        const subcommand = execa_1.default.command('npx lerna list --all --json', { cwd: root });
        subcommand
            .then(({ stdout }) => function_1.pipe(stdout, StringifiedJSON_1.StringifiedJSON(t.array(LernaPackage_1.LernaPackage)).decode.bind(null), E.fold(reject, resolve)))
            .catch(reject);
        return function onCancel() {
            subcommand.cancel();
        };
    });
}
exports.lernaPackages = lernaPackages;
//# sourceMappingURL=lerna-utils.js.map